
%{ 

#define YY_NO_UNPUT

#include <math.h>
#include <stdlib.h>

#include <isis/ivm/isasm.h>
#include "parser.h"

int ISASM_lineno = 1;

%}

%%

\/\/.*      ;
[ \t]       ; 
\n          { ISASM_lineno++; }

var         { return VAR; }
func        { return FUNC; }
param       { return PARAM; }
RetVal      { return RETVAL; }

mov         { return MOV; }

add         { return ADD; }
sub         { return SUB; }
mul         { return MUL; }
div         { return DIV; }
mod         { return MOD; }
neg         { return NEG; }
inc         { return INC; }
dec         { return DEC; }

logicand    { return LOGICAND; }
logicor     { return LOGICOR; }
bitand      { return BITAND; }
bitor       { return BITOR; }
xor         { return XOR; }
not         { return NOT; }
shl         { return SHL; }
shr         { return SHR; }

concat      { return CONCAT; }
getchar     { return GETCHAR; }
setchar     { return SETCHAR; }

cmpe        { return CMPE; }
cmpne       { return CMPNE; }
cmpg        { return CMPG; }
cmpge       { return CMPGE; }
cmpl        { return CMPL; }
cmple       { return CMPLE; }

jmp         { return JMP; }
jz          { return JZ; }
jnz         { return JNZ; }

push        { return PUSH; }
pop         { return POP; }

this        { return THIS; }

call        { return CALL; }
callhost    { return CALLHOST; }
callobj     { return CALLOBJ; }
ret         { return RET; }

-?[0-9]+    { ISASM_lval.int_val = atoi(ISASM_text); return INTEGER; }

-?((([0-9]+)|([0-9]*\.[0-9]+))([eE][-+]?[0-9]+)?)    {
              ISASM_lval.float_val = (float)atof(ISASM_text); return FLOAT; }

[a-zA-Z_][a-zA-Z0-9_]*  { ISASM_lval.name_index = isasm_name_table_add(ISASM_text);  
                        return IDENT; }

\"[^"\n]*["\n] { ISASM_text[ISASM_leng-1] = '\0'; 
         ISASM_lval.name_index = isasm_name_table_add(ISASM_text+1); return STRING; }

.           { return ISASM_text[0]; }

%%

