
#ifndef ISIS_GAME_IVMKEYHANDLER_H_INCLUDED
#define ISIS_GAME_IVMKEYHANDLER_H_INCLUDED 1

#include <string>

#include <isis/ivm.h>

#include <isis/game/IKeyHandler.h>

namespace Isis {

class IVMKeyHandler : public IKeyHandler
{
public:

	IVMKeyHandler(IVM::Script * pScript, const std::string & sFuncname);
	virtual ~IVMKeyHandler();

	virtual void HandleKey(int key, GameApp::ModifierKeys modifiers, 
						   bool pressed);

	IVM::Script * GetScript();
	std::string GetFuncname();

private:

	IVM::Script * m_pScript;
	std::string m_sFuncname;
};

} // namespace Isis

#endif // ISIS_GAME_IVMKEYHANDLER_H_INCLUDED
