
#ifndef ISIS_GAME_IWINDOWCONTAINER_H_INCLUDED
#define ISIS_GAME_IWINDOWCONTAINER_H_INCLUDED 1

#include <isis/util/RefCountObject.h>

namespace Isis {

class GUIWindow;

class IWindowContainer : public virtual RefCountObject, 
						 public virtual IVM::IVMObject
{
public:

	virtual ~IWindowContainer() {}

	virtual GUIWindow * MakeWindow(int x, int y, 
								   int width = 0, int height = 0) = 0;
	virtual GUIWindow * WindowFromPoint(int x, int y,
										bool bCountTransparent = false) = 0;
	virtual void RemoveWindow(GUIWindow * pWindow) = 0;
	virtual void WindowToScreen(int & x, int & y) = 0;
	virtual void ScreenToWindow(int & x, int & y) = 0;
};

}

#endif // ISIS_GAME_IWINDOWCONTAINER_H_INCLUDED
