
#ifndef ISIS_GAME_IMAGE2D_H_INCLUDED
#define ISIS_GAME_IMAGE2D_H_INCLUDED 1

#include <vector>
#include <string>

#include <isis/ivm.h>

namespace Isis {

class Image2D : public IVM::IVMObject
{
public:

	enum Flags
	{
		None = 0x00,
		MirrorH = 0x01,
		MirrorV = 0x02,
		Rot90CW = 0x04,
		TileExtra = 0x08,
		RotTex = 0x10,
		UseTexAlpha = 0x20,
		NoTexAlpha = 0x40
	};

	Image2D();
	virtual ~Image2D();

	virtual void Draw(int iX = 0, int iY = 0, 
		              int iWidth = 0, int iHeight = 0,
					  Flags DrawFlags = None,
					  unsigned int modColor = 0xFFFFFFFF,
					  int iCellX = 0, int iCellY = 0, 
					  int iCellWidth = 0, int iCellHeight = 0) = 0;

	virtual void Draw3D(int iX = 0, int iY = 0, 
		                int iWidth = 0, int iHeight = 0,
					    Flags DrawFlags = None,
					    unsigned int modColor = 0xFFFFFFFF,
					    int iCellX = 0, int iCellY = 0, 
					    int iCellWidth = 0, int iCellHeight = 0) = 0;

	virtual int GetWidth() = 0;
	virtual int GetHeight() = 0;

#ifdef _DEBUG
	static int GetGlobalRefCount();
#endif // _DEBUG

private:

#ifdef _DEBUG
	static int m_iGlobalRefCount;
#endif // _DEBUG

};

} // namespace Isis

#endif // ISIS_GAME_IMAGE2D_H_INCLUDED
