
#ifndef IVM_ISISGAMEPROVIDER_H_INCLUDED
#define IVM_ISISGAMEPROVIDER_H_INCLUDED

#include <map>
#include <string>

#include <isis/ivm.h>

namespace Isis {

class IsisGameProvider : public IVM::ObjectProvider
{
public:

    IsisGameProvider();
    virtual ~IsisGameProvider() {}

    virtual void FillObjectTable(std::vector<std::string> & table);
    virtual IVM::IVMObject * CreateObject(const std::string & objname,
                                   const std::vector<IVM::Value> & InitParams);
 
private:

    enum ObjectType
    {
        OBJECT_IVMGAMEAPP,
		OBJECT_IVMGUIGAME,
        OBJECT_GRAPHICSENGINE,
		OBJECT_SOUNDENGINE,
		OBJECT_PARTICLEMANAGER,
		OBJECT_PARTICLESOURCE
    };

    static std::map<std::string,ObjectType> m_ObjectTable;
    static void FillTable();
};

} // namespace Isis

#endif // IVM_ISISGAMEPROVIDER_H_INCLUDED

