
#ifndef IVM_IVMOBJECT_H_INCLUDED
#define IVM_IVMOBJECT_H_INCLUDED

#include <string>
#include <vector>

#include <isis/util/RefCountObject.h>

namespace IVM {

class Script;
class Value;

class IVMObject : public virtual Isis::RefCountObject
{
public:

    IVMObject();
    virtual ~IVMObject();

    virtual void IVMFillExportTable(std::vector<std::string> & table) = 0;
    virtual bool IVMContainsMethod(const std::string & funcname) = 0;
	virtual IVM::Value IVMCallMethod(const std::string & funcname, 
			                 const std::vector<Value> & parameters) = 0;
#ifdef _DEBUG
	static int GetGlobalRefCount();
#endif // _DEBUG

private:

#ifdef _DEBUG
	static int m_iGlobalRefCount;
#endif // _DEBUG

};

} // namespace IVM

#endif // IVM_IVMOBJECT_H_INCLUDED

