
#ifndef IVM_OBJECTPROVIDER_H_INCLUDED
#define IVM_OBJECTPROVIDER_H_INCLUDED

#include <string>
#include <vector>

#include <isis/util/RefCountObject.h>

namespace IVM {

class IVMObject;
class Value;

class ObjectProvider : public virtual Isis::RefCountObject
{
public:

    ObjectProvider() {}
    virtual ~ObjectProvider() {}

    virtual void FillObjectTable(std::vector<std::string> & table) = 0;
    virtual IVMObject * CreateObject(const std::string & objname,
                                   const std::vector<Value> & InitParams) = 0;
};

} // namespace IVM

#endif // IVM_OBJECTPROVIDER_H_INCLUDED

