#ifndef ISASM_ASSEMBLER_H_INCLUDED 
#define ISASM_ASSEMBLER_H_INCLUDED 1

#include <stdio.h>

#include "isasm_types.h"

#ifdef __cplusplus
extern "C" {
#endif // __cplusplus

// functions

void reset_assembler_state(void);

int isasm_name_table_find(char * string);
int isasm_name_table_add(char * string);
int isasm_name_table_contains(char * string);
const char * isasm_name_table_get(int name_index);

int string_table_find(int name_index);
int string_table_add(int name_index);
int string_table_contains(int name_index);

int symbol_table_find(int name_index, SYM_TYPE type);
int symbol_table_find_global(int name_index);
int symbol_table_find_local(int name_index);
int symbol_table_find_param(int name_index);
int find_closest_symbol(int name_index);
int symbol_table_add(int name_index, SYM_TYPE type);
int symbol_table_contains(int name_index, SYM_TYPE type);
void set_symbol_extra_info(int symbol_index, int extra_info);

int count_global_size(void);

int label_table_find(int name_index);
int label_table_add(int name_index);
void label_table_set(int label_index, int instr_index);
int label_table_get(int label_index);

void lineno_table_add(int line_no, int instr_index);

int isasm_new_func(int name_index);
int isasm_find_func(int name_index);
void isasm_add_param(int name_index);
void isasm_add_local_scalar(int name_index);
void add_local_array(int name_index, int size);
void isasm_calc_func_locals_size(void);
void isasm_clear_func_symbols(void);


#ifdef __cplusplus
}
#endif // __cplusplus

#endif // ASSEMBLER_H_INCLUDED
