
#ifndef ISASM_EXTERNS_H_INCLUDED
#define ISASM_EXTERNS_H_INCLUDED 1

#include "stdio.h"
#include "isasm_types.h"


#ifdef __cplusplus

#include <vector>
#include <string>

extern "C" {
#endif // __cplusplus

extern int isasm_func_num;
extern int instr_num;

extern int ISASM_lineno;
extern FILE * ISASM_in;
void ISASM_error(char * text);
int ISASM_parse(void);
int ISASM_lex(void);
void ISASM_quit(char * format, ... );

#ifdef YYTEXT_POINTER
# if YYTEXT_POINTER > 0
   extern char * ISASM_text;
# else
   extern char[] ISASM_text;
# endif
#else
  extern char * ISASM_text;
#endif


#ifdef __cplusplus

}

extern std::vector<std::string> IsasmNameTable;
extern std::vector<SYM_TABLE_ENTRY> SymbolTable;
extern std::vector<int> StringTable;
extern std::vector<std::pair<int,int> > IsasmLabelTable;
extern std::vector<std::pair<int,int> > LinenoTable;
extern std::vector<ISASM_FUNCTION> IsasmFunctionTable;
extern std::vector<unsigned char> InstructionTable;

extern std::vector<int> JumpTargets;
extern std::vector<int> CallTargets;
extern std::vector<int> CallHostTargets;
extern std::vector<int> CallHostNameIndicies;
extern std::vector<int> CallObjTargets;
extern std::vector<int> CallObjNameIndicies;

#endif // __cplusplus

#endif // EXTERNS_H_INCLUDED

