
#ifndef ISASM_TYPES_H_INCLUDED
#define ISASM_TYPES_H_INCLUDED 1

#include <isis/ivm/iseformat.h>

#ifdef __cplusplus
#include <vector>
extern "C" {
#endif // __cplusplus

// datatypes

typedef enum
{
    SYM_GLOBAL_SCALAR,
    SYM_GLOBAL_ARRAY,
    SYM_LOCAL_SCALAR,
    SYM_LOCAL_ARRAY,
    SYM_PARAM_SCALAR
} SYM_TYPE;

typedef struct
{
    SYM_TYPE type;
    int extra_info;
    int name_index;
} SYM_TABLE_ENTRY;

typedef enum
{
    LVAL_RETVAL,
    LVAL_SCALAR,
    LVAL_ARRAY_LIT,
    LVAL_ARRAY_SYM
} LVAL_TYPE;

typedef struct
{
    LVAL_TYPE type;
    int symbol_index;
    union
    {
        int literal;
        int symbol_index;
    } offset;
} LVAL;

typedef enum
{
    RVAL_LVAL,
    RVAL_STRINGIND,
    RVAL_INTEGER,
    RVAL_FLOAT
} RVAL_TYPE;

typedef struct
{
    RVAL_TYPE type;
    union
    {
        int string_ind;
        int int_val;
        float float_val;
        LVAL lval;
    } val;
} RVAL;


#ifdef __cplusplus

typedef struct
{
    int name_index;
    std::vector<int> param_symbols;
    std::vector<int> local_symbols;
    int first_instr;
    int locals_size;
} ISASM_FUNCTION;

}
#endif // __cplusplus

#endif // TYPES_H_INCLUDED

