
#ifndef ISC_EXTERNS_H_INCLUDED
#define ISC_EXTERNS_H_INCLUDED 1

#include <stdio.h>

#include "isc.h"

#ifdef __cplusplus

#include <vector>
#include <string>

extern "C" {
#endif // __cplusplus

extern int ISC_lineno;
extern FILE * ISC_in;
void ISC_error(char * text);
int ISC_parse(void);
int ISC_lex(void);
void ISC_quit(char * format, ... );

extern int isc_func_num;

#ifdef YYTEXT_POINTER
# if YYTEXT_POINTER > 0
   extern char * ISC_text;
# else
   extern char[] ISC_text;
# endif
#else
  extern char * ISC_text;
#endif

#ifdef __cplusplus

}

extern std::vector<std::string> IscNameTable;
extern std::vector<int> AssignedTable;
extern std::vector<int> LocalTable;
extern std::vector<ISC_FUNCTION> IscFunctionTable;
extern std::vector<std::pair<int,int> > GlobalTable;
extern std::vector<int> RegisterTable;
extern std::vector<int> IscLabelTable;
extern std::vector<LOOP_STRUCT> LoopStack;

extern std::string g_sCurFile;

#endif // __cplusplus

#endif // EXTERNS_H_INCLUDED

