
#ifndef ISIS_UTIL_REFCOUNTOBJECT_H_INCLUDED
#define ISIS_UTIL_REFCOUNTOBJECT_H_INCLUDED

#include <string>
#include <vector>

namespace Isis {

class RefCountObject
{
public:

    RefCountObject();
    virtual ~RefCountObject();

    void AddRef();
    void Release();
	void SafeRelease();

    int GetRefCount();

#ifdef _DEBUG
	static int GetGlobalCount();
#endif // _DEBUG

private:

    int m_iRefCount;

#ifdef _DEBUG
	static int m_iGlobalCount;
#endif // _DEBUG
};

} // namespace Isis

#endif // ISIS_UTIL_REFCOUNTOBJECT_H_INCLUDED

