
#ifndef ISIS_UTIL_ERRORS_H_INCLUDED
#define ISIS_UTIL_ERRORS_H_INCLUDED

#include <stdio.h>

#ifndef DEBUG_MSG_OFF
# define DEBUG_MSG_ON
#endif

#ifndef WARN_MSG_OFF
# define WARN_MSG_ON
#endif

#ifdef DEBUG_MSG_ON
# define ISISERR_ERR_MSG isis_error
# define ISISERR_ERR_MSGL isis_errorl
#else
# define ISISERR_ERR_MSG 
# define ISISERR_ERR_MSGL 
#endif

#define ERR_MSG ISISERR_ERR_MSG("ERR  %s line %d: \n",__FILE__,__LINE__); ISISERR_ERR_MSGL

#ifdef WARN_MSG_ON
# define ISISERR_WARN_MSG isis_error
# define ISISERR_WARN_MSGL isis_errorl
#else
# define ISISERR_WARN_MSG 
# define ISISERR_WARN_MSGL
#endif

#define WARN_MSG ISISERR_WARN_MSG("WARN %s line %d: \n",__FILE__,__LINE__); ISISERR_WARN_MSGL

#ifdef INFO_MSG_ON
# define ISISERR_INFO_MSG isis_error
# define ISISERR_INFO_MSGL isis_errorl
#else
# define ISISERR_INFO_MSG 
# define ISISERR_INFO_MSGL 
#endif

#define INFO_MSG ISISERR_INFO_MSG("INFO %s line %d: \n",__FILE__,__LINE__); ISISERR_INFO_MSGL

#ifdef __cplusplus
extern "C" {
#endif // __cplusplus

void isis_error(char * format, ... );
void isis_errorl(char * format, ... );

#ifdef __cplusplus
}
#endif // __cplusplus

#endif // ISIS_UTIL_ERRORS_H_INCLUDED

