
#include <vector>

#include <isis/game/IVMDestroyCallback.h>

namespace Isis {

IVMDestroyCallback::IVMDestroyCallback(IVM::Script * pScript, 
								 const std::string & sFuncname)
{
	m_pScript = pScript;
	m_sFuncname = sFuncname;

	if (m_pScript)
		m_pScript->AddRef();
}

IVMDestroyCallback::~IVMDestroyCallback()
{
	if (m_pScript)
		m_pScript->Release();
}

void IVMDestroyCallback::DestroyCallback()
{
	if (m_pScript)
	{
		std::vector<IVM::Value> params;
		m_pScript->ExecSync(m_sFuncname,params);
	}
}

IVM::Script * IVMDestroyCallback::GetScript()
{
	return m_pScript;
}

std::string IVMDestroyCallback::GetFuncname()
{
	return m_sFuncname;
}

} // namespace Isis
