
#include <vector>

#include <isis/game/IVMFrameUpdate.h>

namespace Isis {

IVMFrameUpdate::IVMFrameUpdate(IVM::Script * pScript, 
								 const std::string & sFuncname)
{
	m_pScript = pScript;
	m_sFuncname = sFuncname;

	if (m_pScript)
		m_pScript->AddRef();
}

IVMFrameUpdate::~IVMFrameUpdate()
{
	if (m_pScript)
		m_pScript->Release();
}

void IVMFrameUpdate::FrameUpdate()
{
	if (m_pScript)
	{
		std::vector<IVM::Value> params;
		m_pScript->ExecSync(m_sFuncname,params);
	}
}

IVM::Script * IVMFrameUpdate::GetScript()
{
	return m_pScript;
}

std::string IVMFrameUpdate::GetFuncname()
{
	return m_sFuncname;
}

} // namespace Isis
