#ifndef ISIS_GAME_IVMGUIGAME_H_INCLUDED
#define ISIS_GAME_IVMGUIGAME_H_INCLUDED 1

#include <isis/game/GUIGame.h>

namespace Isis {

class IVMGUIGame : public Isis::GUIGame
{
public:

    IVMGUIGame();
    virtual ~IVMGUIGame();

	void GUIInit();
	bool GUIMain();
	void GUIShutdown();

	void RunScript(IVM::Script * pScriptObject);

	virtual void EmptyClick(GUIGame::ClickType click, int x, int y);
    
	virtual void IVMFillExportTable(std::vector<std::string> & table);
    virtual bool IVMContainsMethod(const std::string & funcname);
    virtual IVM::Value IVMCallMethod(const std::string & funcname, 
		const std::vector<IVM::Value> & parameters);

	virtual bool UnhandledException(IsisException & ex);

private:

    IVM::IsisVM * m_pVM;
    IVM::Script * m_pCurScript;

	enum FuncType
    {
        FUNC_RUNSCRIPT
    };

    static std::map<std::string,FuncType> m_ExportTable3;
    static void FillExportTable3();
};

} // namespace Isis

#endif // ISIS_GAME_IVMGUIGAME_H_INCLUDED
