#ifndef ISIS_GAME_IVMGAMEAPP_H_INCLUDED
#define ISIS_GAME_IVMGAMEAPP_H_INCLUDED 1

#include <isis/game/GameApp.h>

namespace Isis {

class IVMGameApp : public Isis::GameApp
{
public:

    IVMGameApp();
    virtual ~IVMGameApp();

    void GameInit();
    bool GameMain();
	void GameShutdown();
	
	void RunScript(IVM::Script * pScriptObject);
    
	virtual void IVMFillExportTable(std::vector<std::string> & table);
    virtual bool IVMContainsMethod(const std::string & funcname);
    virtual IVM::Value IVMCallMethod(const std::string & funcname, 
		const std::vector<IVM::Value> & parameters);

protected:

	void KeyPressed(int key, ModifierKeys modifiers);
	void KeyReleased(int key, ModifierKeys modifiers);

	void MouseMoved(int x, int y);
	void MouseClicked(ClickType click, int x, int y);

private:

    IVM::IsisVM * m_pVM;
    IVM::Script * m_pCurScript;

	enum FuncType
    {
        FUNC_RUNSCRIPT
    };

    static std::map<std::string,FuncType> m_ExportTable2;
    static void FillExportTable2();
};

} // namespace Isis

#endif // ISIS_GAME_IVMGAMEAPP_H_INCLUDED
