
#include <vector>

#include <isis/game/IVMMouseHandler.h>

namespace Isis {

IVMMouseHandler::IVMMouseHandler(IVM::Script * pScript, 
								 const std::string & sFuncname)
{
	m_pScript = pScript;
	m_sFuncname = sFuncname;

	if (m_pScript)
		m_pScript->AddRef();
}

IVMMouseHandler::~IVMMouseHandler()
{
	if (m_pScript)
		m_pScript->Release();
}

void IVMMouseHandler::HandleMouse(int x, int y, GameApp::ClickType type)
{
	if (m_pScript)
	{
		std::vector<IVM::Value> params;
		params.push_back(x);
		params.push_back(y);
		params.push_back((int)type);

		m_pScript->ExecSync(m_sFuncname,params);
	}
}

IVM::Script * IVMMouseHandler::GetScript()
{
	return m_pScript;
}

std::string IVMMouseHandler::GetFuncname()
{
	return m_sFuncname;
}

} // namespace Isis

