
#include <isis/game/SoundEngine.h>
#include <isis/game/Sound.h>

namespace Isis {

void SoundEngine::FillObjectTable()
{
    m_ObjectTable["Sound"]	   = OBJECT_SOUND;
}

void SoundEngine::FillObjectTable(std::vector<std::string> & table)
{
    std::map<std::string,ObjectType>::iterator iter;

    for (iter = m_ObjectTable.begin(); iter != m_ObjectTable.end(); iter++)
    {
        table.push_back(iter->first);
    }
}

IVM::IVMObject * SoundEngine::CreateObject(const std::string & objname,
                                   const std::vector<IVM::Value> & InitParams)
{
    if (m_ObjectTable.end() == m_ObjectTable.find(objname))
        throw IVM::IVMException("object type not found");

    IVM::IVMObject * pObject = NULL;

    switch (m_ObjectTable[objname])
    {
    case OBJECT_SOUND:
        {
            pObject =  new Sound(this);
        } break;
    }

	pObject->AddRef();

    if (pObject->IVMContainsMethod("Init"))
    {
        pObject->IVMCallMethod("Init",InitParams);
    } 
	else if (!InitParams.empty())
    {
        throw IVM::IVMException
			("Init() parameters given, but Init not found");
    }

	pObject->SafeRelease();
    return pObject;
}

} // namespace Isis


