
#include <isis/game/VectorAnimation.h>

namespace Isis {

int VectorAnimation::GetNumFrames()
{
	return (int)m_Frames.size();
}

VectorImage * VectorAnimation::GetFrame(int index)
{
	if (index < 0 || index >= (int)m_Frames.size())
		throw IsisException("Invalid frame index");

	return m_Frames[index];
}

float VectorAnimation::GetFramerate()
{
	return m_fFramerate;
}

std::string VectorAnimation::GetName()
{
	return m_sName;
}

} // namespace Isis

