
#include <zlib.h>

#include <isis/game/VectorImage.h>

namespace Isis {

float VectorImage::GetLeft()
{
    return m_fLeft;
}

float VectorImage::GetRight()
{
    return m_fRight;
}

float VectorImage::GetTop()
{
    return m_fTop;
}

float VectorImage::GetBottom()
{
    return m_fBottom;
}

int VectorImage::ReadInt(gzFile file)
{
	unsigned char bytes[4];

	if (4 != gzread(file,bytes,4))
	{
		gzclose(file);
		throw IsisException("Error reading image file");
	}

	return bytes[0] | (bytes[1] << 8) | 
		   (bytes[2] << 16) | (bytes[3] << 24);
}

unsigned char VectorImage::ReadByte(gzFile file)
{
	unsigned char byte;

	if (1 != gzread(file,&byte,1))
	{
		gzclose(file);
		throw IsisException("Error reading image file");
	}

	return byte;
}

float VectorImage::ReadFloat(gzFile file)
{
	int i = ReadInt(file);
	return *((float*)(&i));
}

} // namespace Isis
