
#include <isis/util/IsisException.h>
#include <isis/util/errors.h>

namespace Isis {

IsisException::IsisException() 
{ 
    m_sMessage = "No message given"; 

    ERR_MSG("IsisException: %s",m_sMessage.c_str());

#ifdef WIN32
#ifdef _DEBUG
	_asm
	{
		int 3
	}
#endif // _DEBUG
#endif // WIN32

}

IsisException::IsisException(const std::string & sMessage) 
{ 
    m_sMessage = sMessage; 

    ERR_MSG("IsisException: %s",m_sMessage.c_str());

#ifdef WIN32
#ifdef _DEBUG
	_asm
	{
		int 3
	}
#endif // _DEBUG
#endif // WIN32

}

IsisException::IsisException(const std::string & sMessage, const std::string & sExtra) 
{ 
    m_sMessage = sMessage + " " + sExtra; 

    ERR_MSG("IsisException: %s",m_sMessage.c_str());

#ifdef WIN32
#ifdef _DEBUG
	_asm
	{
		int 3
	}
#endif // _DEBUG
#endif // WIN32

}

}
