
#ifndef IVM_ISEREADER_H_INCLUDED
#define IVM_ISEREADER_H_INCLUDED 1

#include <zlib.h>

#include <string>

namespace IVM {

class ISEReader
{
public:

    ISEReader();
    virtual ~ISEReader();

    void OpenFile(const std::string & filename);
    void CloseFile();

    void CheckID();
    void ReadMajorMinor(int & major, int & minor);
    int ReadInt();
    float ReadFloat();
    std::string ReadString();
    unsigned char ReadByte(); 

private:

    bool m_bFileOpen;
    gzFile m_pFile;

    std::string tmpfile;

    void ConvertISM(const std::string & oldfile, std::string & newfile);
    void ConvertISS(const std::string & oldfile, std::string & newfile);
};


} // namespace IVM

#endif // IVM_ISEREADER_H_INCLUDED

