
#include <stdio.h>
#include <iostream>

#include <isis/ivm/Script.h>
#include <isis/ivm/IVMException.h>

#include "IVMConsole.h"


namespace IVM {

void IVMConsole::IVMFillExportTable(std::vector<std::string> & table)
{
    table.push_back("print");
    table.push_back("println");

    table.push_back("get");
    table.push_back("getln");
}

bool IVMConsole::IVMContainsMethod(const std::string & funcname)
{
    return (funcname == "print") || 
           (funcname == "println") ||
           (funcname == "get") ||
           (funcname == "getln");
}

Value IVMConsole::IVMCallMethod(const std::string & funcname, 
                               const std::vector<Value> & parameters)
{
    if (funcname == "print")
    {
        std::string text;

        for (unsigned int i = 0; i < parameters.size(); i++)
        {
            text = parameters[i].GetString();

            printf("%s",text.c_str());
        }
    }
    else if (funcname == "println")
    {
        std::string text;

        for (unsigned int i = 0; i < parameters.size(); i++)
        {
            text = parameters[i].GetString();

            printf("%s\n",text.c_str());
        }

        if (0 == parameters.size())
        {
            printf("\n");
        }
    }
    else if (funcname == "get")
    {
        std::string s;
        std::cin >> s;
        return s;
    }
    else if (funcname == "getln")
    {
        char buffer[1024];
        std::cin.getline(buffer,1024);
        return std::string(buffer);
    }
    else
    {
        throw IVMException("function not found in IVMConsole");
    }

	return true;
}


} // namespace IVM
