
#include <stdio.h>

#include <isis/util.h>

#include "Instruction.h"

namespace IVM {


void Instruction::DebugPrint()
{
    fprintf(stderr,"Type: ");

    switch (Type)
    {
    case INSTR_MOV:      fprintf(stderr,"MOV"); break;
    case INSTR_ADD:      fprintf(stderr,"ADD"); break;
    case INSTR_SUB:      fprintf(stderr,"SUB"); break;
    case INSTR_MUL:      fprintf(stderr,"MUL"); break;
    case INSTR_DIV:      fprintf(stderr,"DIV"); break;
    case INSTR_MOD:      fprintf(stderr,"MOD"); break;
    case INSTR_NEG:      fprintf(stderr,"NEG"); break;
    case INSTR_INC:      fprintf(stderr,"INC"); break;
    case INSTR_DEC:      fprintf(stderr,"DEC"); break;
    case INSTR_LOGICAND: fprintf(stderr,"LOGICAND"); break;
    case INSTR_LOGICOR:  fprintf(stderr,"LOGICOR"); break;
    case INSTR_BITAND:   fprintf(stderr,"BITAND"); break;
    case INSTR_BITOR:    fprintf(stderr,"BITOR"); break;
    case INSTR_XOR:      fprintf(stderr,"XOR"); break;
    case INSTR_NOT:      fprintf(stderr,"NOT"); break;
    case INSTR_SHL:      fprintf(stderr,"SHL"); break;
    case INSTR_SHR:      fprintf(stderr,"SHR"); break;
    case INSTR_CONCAT:   fprintf(stderr,"CONCAT"); break;
    case INSTR_GETCHAR:  fprintf(stderr,"GETCHAR"); break;
    case INSTR_SETCHAR:  fprintf(stderr,"SETCHAR"); break;
    case INSTR_CMPE:     fprintf(stderr,"CMPE"); break;
    case INSTR_CMPNE:    fprintf(stderr,"CMPNE"); break;
    case INSTR_CMPG:     fprintf(stderr,"CMPG"); break;
    case INSTR_CMPGE:    fprintf(stderr,"CMPGE"); break;
    case INSTR_CMPL:     fprintf(stderr,"CMPL"); break;
    case INSTR_CMPLE:    fprintf(stderr,"CMPLE"); break;
    case INSTR_JMP:      fprintf(stderr,"JMP"); break;
    case INSTR_JZ:       fprintf(stderr,"JZ"); break;
    case INSTR_JNZ:      fprintf(stderr,"JNZ"); break;
    case INSTR_PUSH:     fprintf(stderr,"PUSH"); break;
    case INSTR_POP:      fprintf(stderr,"POP"); break;
    case INSTR_CALL:     fprintf(stderr,"CALL"); break;
    case INSTR_CALLHOST: fprintf(stderr,"CALLHOST"); break;
    case INSTR_CALLOBJ:  fprintf(stderr,"CALLOBJ"); break;
    case INSTR_THIS:     fprintf(stderr,"THIS"); break;
    case INSTR_RET:      fprintf(stderr,"RET"); break;
    default:             fprintf(stderr,"UNKNOWN"); break;
    }

    fprintf(stderr,"\n");
    
    for (unsigned int i = 0; i < OpList.size(); i++)
    {
        OpList[i].DebugPrint();
    }
}

}
