
#ifndef IVM_OPERAND_H_INCLUDED
#define IVM_OPERAND_H_INCLUDED

#include <isis/ivm/iseformat.h> 

namespace IVM {

class ISEReader;

struct Operand
{
    void LoadLValue(ISEReader & reader);
    void LoadRValue(ISEReader & reader);
    void LoadLabel(ISEReader & reader);
    void LoadCall(ISEReader & reader);
    void LoadCallHost(ISEReader & reader);
    void LoadCallObject(ISEReader & reader);

    void DebugPrint();

    OPERAND_TYPE Type;

    union
    {
        int iValue;
        float fValue;
        int iStringIndex;
        int iStackIndex;
        int iInstrNum;
        int iFuncIndex;
        int iHostFuncIndex;
        int iHostObjIndex;
    };

    int iExtraInfo;
};

} // namespace IVM

#endif // IVM_OPERAND_H_INCLUDED

