
#include <stdio.h>

#include <isis/util.h>

#include <isis/ivm/IVMException.h>

#include "Operand.h"

namespace IVM {

void Operand::DebugPrint()
{
    fprintf(stderr,"  Operand: ");

    switch (Type)
    {
    case OP_STRING: { fprintf(stderr,"String Index: %d\n",
                              iStringIndex); } break;
    case OP_INTEGER: { fprintf(stderr,"Integer: %d\n",iValue); } break;
    case OP_FLOAT: { fprintf(stderr,"Float: %f\n",fValue); } break;
    case OP_RETVAL: { fprintf(stderr,"RetVal\n"); } break;
    case OP_SCALAR: { fprintf(stderr,"Scalar index: %d\n",
                              iStackIndex); } break;
    case OP_ARRAY: { fprintf(stderr,"Array, index: %d offset: %d\n",
                             iStackIndex,iExtraInfo); } break;
    case OP_LABEL: { fprintf(stderr,"Instruction jump: %d\n",
                             iInstrNum); } break;
    case OP_FUNCINDEX: { fprintf(stderr,"Function index: %d\n",
                                iFuncIndex); } break;
    case OP_HOSTFUNC: { fprintf(stderr,"HostAPI index: %d\n",
                                iHostFuncIndex); } break;
    case OP_HOSTOBJ: { fprintf(stderr,"HostObj index: %d\n",
                                iHostObjIndex); } break;
    }
}

}

