
#include <isis/util.h>

#include <isis/ivm/IVMException.h>
#include <isis/ivm/Script.h>

#include "ISEStruct.h"

namespace IVM {

bool Script::IsLoaded()
{
    return m_bLoaded;
}

bool Script::ContainsFunction(const std::string & funcname)
{
    return (-1 != FindFuncIndex(funcname));
}

int Script::FindFuncIndex(const std::string & funcname)
{
    if (!m_bLoaded)
        return -1;

    for (unsigned int i = 0; i < m_pISE->FunctionTable.size(); i++)
    {
        if (m_pISE->FunctionTable[i].sName == funcname)
            return i;
    }

    return -1;
}

void Script::SetRetVal(const Value & retval)
{
    m_RetVal = retval;
}

Value Script::GetRetVal()
{
    return m_RetVal;
}

IsisVM * Script::GetParentVM()
{
    return m_pParentVM;
}

} // namespace IVM

