
#include <isis/util.h>

#include <isis/ivm/Script.h>
#include <isis/ivm/IVMVector.h>

#include "ISEStruct.h"

namespace IVM {

void Script::FillObjectTable(std::vector<std::string> & table)
{
	IVMVector * pVector = new IVMVector();
	pVector->AddRef();

	std::vector<Value> params;
	params.push_back(pVector);

	ExecSync("FillObjectTable",params);

	for (int i = 0; i < pVector->Size(); i++)
	{
		table.push_back(pVector->Get(i).GetString());
	}

	pVector->Release();
}

IVMObject * Script::CreateObject(const std::string & objname,
                                 const std::vector<IVM::Value> & InitParams)
{
	IVMVector * pVector = new IVMVector();
	pVector->AddRef();

	for (unsigned int i = 0; i < InitParams.size(); i++)
	{
		pVector->Add(InitParams[i]);
	}

	std::vector<Value> params;
	params.push_back(objname);
	params.push_back(pVector);

	ExecSync("CreateObject",params);

	pVector->Release();

    return GetRetVal().GetObjPtr();
}

} // namespace IVM

