
#include <stdio.h>

#include <isis/util.h>

#include <isis/ivm/Value.h>

#include <isis/ivm/IVMObject.h>
#include <isis/ivm/IVMException.h>

namespace IVM {

void Value::AssignNone()
{
    Free();

    Type = None;
    iValue = 0;
}

void Value::AssignInteger(int value)
{
    Free();

    Type = Integer;
    iValue = value;
}

void Value::AssignFloat(float value)
{
    Free();

    Type = Float;
    fValue = value;
}

void Value::AssignString(const std::string & value)
{
    Free();

    Type = String;
    psValue = new std::string(value);
}

void Value::AssignObjPtr(IVMObject * value)
{
    Free();

    Type = ObjPtr;
    pObject = value;

    if (NULL != pObject)
    {
        pObject->AddRef();
    }
}

}

